% Copyright (c) 2014 TU Dresden
% All rights reserved.
% See accompanying license.txt for details.
%


% This example shows how a random GFDM signal can be
% created. Additionally, an OFDM signal with an equal length is
% created, and the Spectrum of both is compared.

%% Create parameter sets for GFDM and OFDM
 gfdm = get_defaultGFDM('TTI');
% gfdm.K = 512;
% gfdm.Kset = 100:200;  % Only allocate some subcarriers
% gfdm.pulse = 'rc';
% gfdm.a = 0.1;
% gfdm.Mon = 14;

 ofdm = gfdm;
ofdm.pulse = 'rc_td';  % use RC_TD with rolloff 0 to make a
ofdm.a = 0;            % rectangular filter
ofdm.M = 1;
ofdm.Mon = 1;
ofdm.L = ofdm.K;
EbN0Vec=(0:2:20);

%% Generate the signals
% Currently only works without CP
% assert(~isfield(gfdm, 'Ncp') || gfdm.Ncp == 0);

% Allocate enough space for the signals
blockLen = gfdm.M*gfdm.K;
% sGFDM = zeros(nB * blockLen, 1);
% sOFDM = zeros(size(sGFDM));
for kk=1:length(EbN0Vec)
 snrdb=EbN0Vec(kk)+10*log10(2);
 numErrsmf=0;
    numErrszf=0;
    numErrsmmse=0;
    % Create an OFDM signal
    % create symbols
s = get_random_symbols(ofdm);
s_length=length(s);
  % map them to qam and to the D matrix
D = do_map(ofdm, do_qammodulate(s, 2));

x = do_modulate(ofdm, D);
% sOFDM((b-1)*blockLen+(m-1)*gfdm.K+(1:gfdm.K)) = x
%     for m = 1:gfdm.M
%         D2 = do_map(ofdm, do_qammodulate(get_random_symbols(ofdm), ofdm.mu));
%         x = do_modulate(ofdm, D2);
%         sOFDM((b-1)*blockLen+(m-1)*gfdm.K+(1:gfdm.K)) = x;
%     end


xch = awgn(x, snrdb,'measured');

dhat_mf = do_unmap(ofdm, do_demodulate(ofdm, xch, 'MF'));
dhat_zf = do_unmap(ofdm, do_demodulate(ofdm, xch, 'ZF'));
dhat_se = do_unmap(ofdm, do_demodulate(ofdm, xch, 'MMSE'));


shm = do_qamdemodulate(dhat_mf, 2);
shz = do_qamdemodulate(dhat_zf,2);
she = do_qamdemodulate(dhat_se, 2);

nErrorsmf=biterr(s,shm);
numErrsmf=numErrsmf+nErrorsmf;
bermfawgn(kk)=numErrsmf/s_length;


% berzfawgn=zeros(1,length(EbN0Vec));
nErrorszf=biterr(s,shz);
numErrszf=numErrszf+nErrorszf;
berzfawgn(kk)=numErrszf/s_length;

% bermmseawgn=zeros(1,length(EbN0Vec));
nErrorsmmse=biterr(s,she);
numErrsmmse=numErrsmmse+nErrorsmmse;
bermmseawgn(kk)=numErrsmmse/s_length;


end
berth=berawgn(EbN0Vec,'qam',4);
 semilogy(EbN0Vec,berth,'b*-')
 hold on
semilogy(EbN0Vec,bermfawgn,'go-')
 hold on
 semilogy(EbN0Vec,berzfawgn,'y^-')
  hold on
  semilogy(EbN0Vec,bermmseawgn,'ro-')
%     hold on
%  semilogy(EbN0Vec,bermffiber,'co-')
%     hold on
%   semilogy(EbN0Vec,berzffiber,'g^-')
  legend(' QAM BER Theory','OFDM MF awgn ','OFDM ZF awgn','OFDM MMSE awgn')

%   legend('QAM BER Theory','GFDM MF awgn ','GFDM ZF awgn','GFDM MMSE awgn','GFDM MF fiber 80km ','GFDM ZF fiber 80 km')
title('  QAM  awgn');
xlabel('EbN0(db)');
ylabel('BER');
%% Plot the resulting PSD
% f = linspace(-gfdm.K/2, gfdm.K/2, 2*length(sGFDM)+1); f = f(1:end-1)';
% plot( mag2db(fftshift(abs(fft(x, 2*length(x)))))/2, 'b');
% hold on;
% plot(f, mag2db(fftshift(abs(fft(sGFDM, 2*length(sGFDM)))))/2, 'r');
% hold off;
% ylim([-40, 30]);
% xlabel('f/F'); ylabel('PSD [dB]');
% grid()
% legend({'OFDM', 'GFDM'});